//---------------------------------------------------------------------------
//
// TDirectDrawFastForm - fast Flicker free form for Borland C++ Builder
// -------------------  	& DirectX, no visible controls
//
// (c) 1997 by Darren John Dwyer - All Rights Reserved
//
//
// Disclaimer:
//
// All source code, object files, documentation files, etc. included as
// part this package are supplied subject to the rules in the attached file
// LICENCE.DOC
//
// Please read the file LICENCE.DOC now.
//
//---------------------------------------------------------------------------
#ifndef TDirectDrawFastForm1H
#define TDirectDrawFastForm1H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Grids.hpp>
#include <vcl\MPlayer.hpp>
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
#include "TDirectDraw.h"
//---------------------------------------------------------------------------
class TDirectDrawFastForm : public TForm
{
    //----------------------------------------------------------------------------------
	// General Notes:
    //
    // (1)	This object "TDirectDrawForm" is designed to be used with the "TDirectDraw"
    //		object written by the same author and will not work without "TDirectDraw".
    //
    // (2)	A TDirectDrawForm is meant to behave exactly the same as the standard TForm
    //		in the manner of dropping components onto the form, etc. except that the
    //		TDirectDrawForm works only with DirectX exclusive mode (ie. full-screen)
	//
    //----------------------------------------------------------------------------------

__published:

public:

    //----------------------------------------------------------------------------------
    // Notes:	Should not need to overload these methods
    //----------------------------------------------------------------------------------

					__fastcall 	TDirectDrawFastForm(TComponent* Owner);
	virtual			__fastcall 	~TDirectDrawFastForm();

	virtual void	__fastcall 	Repaint();

    //----------------------------------------------------------------------------------
    // Notes: At the moment, forms are still moveable, attempting to figure way around
    //		  this. For this release: BeforeMove(), AfterMove() and Moveable do not work
    //----------------------------------------------------------------------------------

	virtual void 	__fastcall	BeforeMove();
    virtual	void	__fastcall	AfterMove();

	__property	bool			Moveable = {read=fFormIsMoveable,write=fFormIsMoveable,default=true};

    //----------------------------------------------------------------------------------
	// Notes: FramesFlipped is a counter that you can read/write and which is incremented
    //			each time a section of the screen has been updated.
    //----------------------------------------------------------------------------------

   	__property	unsigned long	FramesFlipped = {read=fFramesFlipped,write=fFramesFlipped,default=0};

protected:

    //----------------------------------------------------------------------------------
    // Notes:	Internal vars & methods, etc.
    //----------------------------------------------------------------------------------

	void 		__fastcall	WndProc(Messages::TMessage &Message);
	void 		__fastcall	PaintHandler(Messages::TWMPaint &Message);
	void 		__fastcall 	PaintWindow(HDC hdc);
	void		__fastcall	PaintControls(HDC hdc, TControl* First);
	void 		__fastcall	Func3( HWND Handle, HDC hdc );
    void 		__fastcall	Func2( HDC hdc );
    void		__fastcall	Func4( HDC hdc, HMENU hmenu );

private:

    //----------------------------------------------------------------------------------
    // Notes:	Internal vars & methods, etc.
    //----------------------------------------------------------------------------------

   	bool				fHandlingWMPAINT;
  	bool*				fIsGraphic;
    bool				fFormIsMoveable;
	unsigned long		fFramesFlipped;
	int					fBorderX;
	int					fBorderY;
    int					fMinimizeX;
	int					fCaptionHeight;
    bool				fFormIsBeingRestored;
    bool				fFormIsBeingMinimized;
    bool				fFormIsBeingMaximized;
};
//---------------------------------------------------------------------------
extern TDirectDrawFastForm *DirectDrawFastForm;
//---------------------------------------------------------------------------
#endif


